javax.transaction

## Interface TransactionSynchronizationRegistry

-     public interface TransactionSynchronizationRegistry

  This interface is intended for use by system level application server components such as persistence managers, resource adapters, as well as EJB and Web application components. This provides the ability to register synchronization objects with special ordering semantics, associate resource objects with the current transaction, get the transaction context of the current transaction, get current transaction status, and mark the current transaction for rollback. This interface is implemented by the application server by a stateless service object. The same object can be used by any number of components with thread safety.

  In standard application server environments, an instance implementing this interface can be looked up by a standard name via JNDI. The standard name is java:comp/TransactionSynchronizationRegistry.

  Since:
    JTA 1.1

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object` | `getResource(Object key)` Get an object from the Map of resources being managed for the transaction bound to the current thread at the time this method is called.
    `boolean` | `getRollbackOnly()` Get the rollbackOnly status of the transaction bound to the current thread at the time this method is called.
    `Object` | `getTransactionKey()` Return an opaque object to represent the transaction bound to the current thread at the time this method is called.
    `int` | `getTransactionStatus()` Return the status of the transaction bound to the current thread at the time this method is called.
    `void` | `putResource(Object key, Object value)` Add or replace an object in the Map of resources being managed for the transaction bound to the current thread at the time this method is called.
    `void` | `registerInterposedSynchronization(Synchronization sync)` Register a Synchronization instance with special ordering semantics.
    `void` | `setRollbackOnly()` Set the rollbackOnly status of the transaction bound to the current thread at the time this method is called.

- - ### Method Detail

    - #### getTransactionKey

          Object getTransactionKey()

      Return an opaque object to represent the transaction bound to the current thread at the time this method is called. This object overrides hashCode and equals to allow its use as the key in a hashMap for use by the caller. If there is no transaction currently active, return null.

      This object will return the same hashCode and compare equal to all other objects returned by calling this method from any component executing in the same transaction context in the same application server.

      The toString method returns a String that might be usable by a human reader to usefully understand the transaction context. The toString result is otherwise not defined. Specifically, there is no forward or backward compatibility guarantee of the results of toString.

      The object is not necessarily serializable, and has no defined behavior outside the virtual machine whence it was obtained.

      Returns:
        an opaque object representing the transaction bound to the current thread at the time this method is called.
      Since:
        JTA 1.1

    - #### putResource

          void putResource(Object key,
                         Object value)

      Add or replace an object in the Map of resources being managed for the transaction bound to the current thread at the time this method is called. The supplied key should be of an caller- defined class so as not to conflict with other users. The class of the key must guarantee that the hashCode and equals methods are suitable for use as keys in a map. The key and value are not examined or used by the implementation. The general contract of this method is that of `Map.put(Object, Object)` for a Map that supports non-null keys and null values. For example, if there is already an value associated with the key, it is replaced by the value parameter.
      Parameters:
        `key` - the key for the Map entry.
        `value` - the value for the Map entry.
      Throws:
        `IllegalStateException` - if no transaction is active.
        `NullPointerException` - if the parameter key is null.
      Since:
        JTA 1.1

    - #### getResource

          Object getResource(Object key)

      Get an object from the Map of resources being managed for the transaction bound to the current thread at the time this method is called. The key should have been supplied earlier by a call to putResouce in the same transaction. If the key cannot be found in the current resource Map, null is returned. The general contract of this method is that of `Map.get(Object)` for a Map that supports non-null keys and null values. For example, the returned value is null if there is no entry for the parameter key or if the value associated with the key is actually null.
      Parameters:
        `key` - the key for the Map entry.
      Returns:
        the value associated with the key.
      Throws:
        `IllegalStateException` - if no transaction is active.
        `NullPointerException` - if the parameter key is null.
      Since:
        JTA 1.1

    - #### registerInterposedSynchronization

          void registerInterposedSynchronization(Synchronization sync)

      Register a Synchronization instance with special ordering semantics. Its beforeCompletion will be called after all SessionSynchronization beforeCompletion callbacks and callbacks registered directly with the Transaction, but before the 2-phase commit process starts. Similarly, the afterCompletion callback will be called after 2-phase commit completes but before any SessionSynchronization and Transaction afterCompletion callbacks.

      The beforeCompletion callback will be invoked in the transaction context of the transaction bound to the current thread at the time this method is called. Allowable methods include access to resources, e.g. Connectors. No access is allowed to "user components" (e.g. timer services or bean methods), as these might change the state of data being managed by the caller, and might change the state of data that has already been flushed by another caller of registerInterposedSynchronization. The general context is the component context of the caller of registerInterposedSynchronization.

      The afterCompletion callback will be invoked in an undefined context. No access is permitted to "user components" as defined above. Resources can be closed but no transactional work can be performed with them.

      If this method is invoked without an active transaction context, an IllegalStateException is thrown.

      If this method is invoked after the two-phase commit processing has started, an IllegalStateException is thrown.

      Parameters:
        `sync` - the Synchronization instance.
      Throws:
        `IllegalStateException` - if no transaction is active.
      Since:
        JTA 1.1

    - #### getTransactionStatus

          int getTransactionStatus()

      Return the status of the transaction bound to the current thread at the time this method is called. This is the result of executing TransactionManager.getStatus() in the context of the transaction bound to the current thread at the time this method is called.
      Returns:
        the status of the transaction bound to the current thread at the time this method is called.
      Since:
        JTA 1.1

    - #### setRollbackOnly

          void setRollbackOnly()

      Set the rollbackOnly status of the transaction bound to the current thread at the time this method is called.
      Throws:
        `IllegalStateException` - if no transaction is active.
      Since:
        JTA 1.1

    - #### getRollbackOnly

          boolean getRollbackOnly()

      Get the rollbackOnly status of the transaction bound to the current thread at the time this method is called.
      Returns:
        the rollbackOnly status.
      Throws:
        `IllegalStateException` - if no transaction is active.
      Since:
        JTA 1.1

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.